public:
	// enkeyDEV: ICS
	void	MOD_ProcessFileIncStatus(CSafeMemFile* data,uint32 size, bool readHash = false, CClientFileStatus* fileStatus = NULL);
	uint32	GetIncompletePartVersion()	{return m_incompletepartVer;}
	bool	MOD_IsPendingListEmpty()      {return m_PendingBlocks_list.IsEmpty();}
	// <--- enkeyDEV: ICS
protected:
	// MOD BEGIN netfinity:
	friend	class CClientDetailDialog;
	friend	class CClientDetailPage;
	friend	class CClientFileStatus;
	friend	class CUploadQueue;
	friend	class CPartFile;
	friend	class CUploadListCtrl;
public:
	uint32	GetScore(bool sysvalue, bool isdownloading = false, bool onlybasevalue = false, bool paybackslot = false) const;
	bool	MOD_IsDifferentPartBlock();
	bool	MOD_SupportIntelligentChunkSelection() const { return (m_incompletepartVer > 0); }
	CBytes	MOD_GetMaxTransfer(bool checkLastTransfer = false);
	bool	MOD_IsPartialSource();
	CBytesPerSecond	MOD_GetEstimatedDownloadRate(void) const;
	CBytesPerSecond	MOD_GetEstimatedUploadRate(void) const;
	void	MOD_SendOutOfPartReqsAndFileNotFound(void);
private:
	void	MOD_Init_Post();
	void	MOD_Destruct_Post();
	void	MOD_ClearHelloProperties_Post();
	void	MOD_SendMuleInfoPacket_AddTags(CList<CTag*> *etTags);
	void	MOD_ProcessMuleInfoPacket_Pre();
	void	MOD_ProcessMuleInfoPacket_Post();
	void	MOD_SendHelloTypePacket_AddTags(CList<CTag*> *ctTags);
	void	MOD_ResetFileStatusInfo_Pre();

	// Connection management
	CTick						m_tickLastFailedToConnect;
public:
	bool						m_bPassiveConnectOnly;
	// Source management
private:
	CMilliSeconds				m_ReaskSpread;
	// Anti Leech (Not really anti leech, but for statistics)
public:
	bool					m_bIsModifiedClient;	//!< Client appears not to be an official eMule client
	bool					m_bHasClonedModString;	//!< Client has copied our Mod string (not used yet!)
	// Download slot management
private:
	uint32						m_lastBlockOffset;
	CTick						m_dwNoNeededPartsPending;
	// Upload slot management
	CMilliSeconds				m_dwUploadTimeBonus;
	CTick						m_dwRemovePending;
	bool						m_bSlotGivenIsPayback;
	uint32						m_dwSlotGivenScore;
	CSafePtr<CClientFileStatus>	m_pSlotGivenForFile;
	// Statistics
	CBytes						m_qwCumulativeDownloadBytes;
	CBytes						m_qwCumulativeUploadBytes;
	CSeconds					m_dwCumulativeDownloadTime;
	CSeconds					m_dwCumulativeUploadTime;
	// Workarounds
public:
	// MOD END netfinity
	// enkeyDEV: ICS
private:
	uint32	m_incompletepartVer;
	// <--- enkeyDEV: ICS
public:	// It's a Mod, lacy coding is what you should expect
	uchar						m_LastFailedFileNameReqHash[16];
	CClientFileStatusList		m_FileStatusList;
	CSafePtr<CClientFileStatus>	m_pUpFileStatus;
	CSafePtr<CClientFileStatus>	m_pDownFileStatus;

	const CString	GetClientModVer() const;
